import java.awt.Color;

import javalib.worldimages.*;
import javalib.worldcanvas.*;
import javalib.funworld.*;
import tester.Tester;

// test the display of images for the apple orchard game and run the game
public class AppleOrchardRunner{
  
  ExamplesAppleOrchard eao = new ExamplesAppleOrchard();

  WorldCanvas c1 = new WorldCanvas(400, 400);
  WorldCanvas c2 = new WorldCanvas(400, 400);

  WorldImage appleImage = this.eao.redApple.appleImage();
  WorldImage basketImage = this.eao.b.basketImage();

  WorldImage worldImage = this.eao.myWorld.makeImage();
  
  // show the apple and the basket on one canvas 
  boolean makeDrawing1 = 
      c1.show() && 
      c1.drawImage(this.appleImage) &&
      c1.drawImage(this.basketImage);
  
  // show the apple and the basket on one canvas 
  boolean makeDrawing2 = 
      c2.show() && 
      c2.drawImage(this.worldImage);

  // run the game
  boolean run(){
    return this.eao.myWorld.bigBang(400, 400, 0.1);    
  }
  
  // invoke this method to run the apple orchard game
  public static void main(String [] argv){
    AppleOrchardRunner aor = new AppleOrchardRunner();
    aor.run();
  }
}